local _, ns = ...
local B, C, L, DB = unpack(ns)
local P = B:GetModule("Plus")
local Bar = B:GetModule("Actionbar")
-----------------
-- Credit: ElvUI
-----------------
local NDui_ActionBar = {
	"NDui_ActionBar1",
	"NDui_ActionBar2",
	"NDui_ActionBar3",
	"NDui_ActionBar4",
	"NDui_ActionBar5",
	"NDui_CustomBar",
	"NDui_ActionBarPet",
	"NDui_ActionBarStance",
}

function P:FadeBlingTexture(cooldown, alpha)
	if not cooldown then return end
	cooldown:SetBlingTexture(alpha > 0.5 and [[Interface\Cooldown\star4]] or P.Blank)
end

function P:FadeBlings(alpha)
	for _, button in pairs(Bar.buttons) do
		P:FadeBlingTexture(button.cooldown, alpha)
	end
end

function P:Bar_OnEnter()
	if not P.fadeParent.mouseLock then
		P:UIFrameFadeIn(P.fadeParent, P.fadeDuration, P.fadeParent:GetAlpha(), 1)
		P:FadeBlings(1)
	end
end

function P:Bar_OnLeave()
	if not P.fadeParent.mouseLock then
		P:UIFrameFadeOut(P.fadeParent, P.fadeDuration, P.fadeParent:GetAlpha(), P.fadeAlpha)
		P:FadeBlings(P.fadeAlpha)
	end
end

function P:FadeParent_OnEvent()
	if CastingInfo() or ChannelInfo() or UnitExists('target') or UnitExists('focus')
	or UnitAffectingCombat('player') or (UnitHealth('player') ~= UnitHealthMax('player')) then
		self.mouseLock = true
		P:UIFrameFadeIn(self, P.fadeDuration, self:GetAlpha(), 1)
		P:FadeBlings(1)
	else
		self.mouseLock = false
		P:UIFrameFadeOut(self, P.fadeDuration, self:GetAlpha(), P.fadeAlpha)
		P:FadeBlings(P.fadeAlpha)
	end
end

function P:HookActionBar()
	for _, v in pairs(NDui_ActionBar) do
		local bar = _G[v]
		if bar then
			bar:SetParent(P.fadeParent)
			bar:HookScript("OnEnter", P.Bar_OnEnter)
			bar:HookScript("OnLeave", P.Bar_OnLeave)
		end
	end

	for _, button in pairs(Bar.buttons) do
		button:HookScript("OnEnter", P.Bar_OnEnter)
		button:HookScript("OnLeave", P.Bar_OnLeave)	
	end
end

function P:GlobalFade()
	if not NDuiPlusDB["GlobalFade"] then return end
	if not NDuiDB["Actionbar"]["Enable"] then return end

	P.fadeAlpha = NDuiPlusDB["GlobalFadeAlpha"] or .1
	P.fadeDuration = NDuiPlusDB["GlobalFadeDuration"] or .3

	P.fadeParent = CreateFrame('Frame', 'NDui_ABFade', _G.UIParent)
	P.fadeParent:SetAlpha(P.fadeAlpha)
	P.fadeParent:SetScript('OnEvent', P.FadeParent_OnEvent)

	if NDuiPlusDB["GlobalFade_Combat"] then
		P.fadeParent:RegisterEvent('PLAYER_REGEN_DISABLED')
		P.fadeParent:RegisterEvent('PLAYER_REGEN_ENABLED')
	end

	if NDuiPlusDB["GlobalFade_Target"] then
		P.fadeParent:RegisterEvent('PLAYER_TARGET_CHANGED')
	end

	if NDuiPlusDB["GlobalFade_Cast"] then
		P.fadeParent:RegisterUnitEvent('UNIT_SPELLCAST_START', 'player')
		P.fadeParent:RegisterUnitEvent('UNIT_SPELLCAST_STOP', 'player')
		P.fadeParent:RegisterUnitEvent('UNIT_SPELLCAST_CHANNEL_START', 'player')
		P.fadeParent:RegisterUnitEvent('UNIT_SPELLCAST_CHANNEL_STOP', 'player')
	end

	if NDuiPlusDB["GlobalFade_Health"] then
		P.fadeParent:RegisterUnitEvent('UNIT_HEALTH', 'player')
	end

	C_Timer.After(.5, P.HookActionBar)
end