local _, ns = ...
local B, C, L, DB = unpack(ns)
local P = B:GetModule("Plus")

local _G = getfenv(0)

function P:PallyPower()
	if not IsAddOnLoaded("PallyPower") then return end

	B.StripTextures(PallyPowerBlessingsFrame)
	B.SetBD(PallyPowerBlessingsFrame)
	B.ReskinClose(PallyPowerBlessingsFrameCloseButton)
	B.ReskinCheck(PallyPowerBlessingsFrameFreeAssign)
	B.ReskinIcon(PallyPowerBlessingsFrameAuraGroup1AuraHeaderIcon)

	local buttons = {
		"PallyPowerBlessingsFrameRefresh",
		"PallyPowerBlessingsFrameClear",
		"PallyPowerBlessingsFrameAutoAssign",
		"PallyPowerBlessingsFrameReport",
		"PallyPowerBlessingsFrameOptions",
	}
	for _, button in next, buttons do
		B.Reskin(_G[button])
	end

	for i = 1, 9 do
		local icon = _G["PallyPowerBlessingsFrameClassGroup"..i.."ClassButtonIcon"]
		if icon then
			B.ReskinIcon(icon)
		end
	end

	local function reskinIcon(icon)
		if not icon then return end
		icon:SetTexCoord(unpack(DB.TexCoord))
	end

	for i = 1, 15 do
		local frameName = "PallyPowerBlessingsFramePlayer"..i
		reskinIcon(_G[frameName.."Icon1"])
		reskinIcon(_G[frameName.."Icon2"])
		reskinIcon(_G[frameName.."Icon3"])
		reskinIcon(_G[frameName.."Icon4"])
		reskinIcon(_G[frameName.."Icon5"])
		reskinIcon(_G[frameName.."Icon6"])
		reskinIcon(_G[frameName.."AIcon1"])
		reskinIcon(_G[frameName.."AIcon2"])
		reskinIcon(_G[frameName.."AIcon3"])
		reskinIcon(_G[frameName.."CIcon1"])
		reskinIcon(_G[frameName.."CIcon2"])
		reskinIcon(_G[frameName.."Aura1Icon"])

		for cNum = 1, PALLYPOWER_MAXCLASSES do
			reskinIcon(_G[frameName.."Class"..cNum.."Icon"])
		end
	end

	local function hook_SetBackdropColor(self, r, g, b, a)
		self.bg:SetVertexColor(r, g, b, a)
	end

	local function reskinBackdrop(frame)
		frame:SetBackdrop(nil)
		frame.SetBackdrop = B.Dummy
		frame.bg = frame:CreateTexture(nil, "BACKGROUND")
		frame.bg:SetAllPoints()
		frame.bg:SetTexture(DB.normTex)
		hooksecurefunc(frame, "SetBackdropColor", hook_SetBackdropColor)
	end

	reskinBackdrop(PallyPowerAura)
	reskinBackdrop(PallyPowerRF)
	reskinBackdrop(PallyPowerAuto)

	local icons = {
		"PallyPowerAutoIcon",
		"PallyPowerRFIcon",
		"PallyPowerRFIconSeal",
		"PallyPowerAuraIcon",
	}
	for _, icon in next, icons do
		reskinIcon(_G[icon])
	end

	for cbNum = 1, PALLYPOWER_MAXCLASSES do
		reskinBackdrop(_G["PallyPowerC"..cbNum])
		reskinIcon(_G["PallyPowerC"..cbNum.."ClassIcon"])
		reskinIcon(_G["PallyPowerC"..cbNum.."BuffIcon"])
		for pbNum = 1, PALLYPOWER_MAXPERCLASS do
			reskinBackdrop(_G["PallyPowerC"..cbNum.."P"..pbNum])
			reskinIcon(_G["PallyPowerC"..cbNum.."P"..pbNum.."BuffIcon"])
		end
	end
end